* Area Average and RMS Data Generator
* Created by: Bryan M. Williams on September 11, 2013

Function main(args)
ctl1=subwrd(args,1)
ctl2=subwrd(args,2)
start=subwrd(args,3)
fhr=subwrd(args,4)
level1=subwrd(args,5)
level2=subwrd(args,6)
level3=subwrd(args,7)

latlon=read('LatLon')
lon1=subwrd(latlon,2)
lon2=subwrd(latlon,3)
lat1=subwrd(latlon,4)
lat2=subwrd(latlon,5)

say ' '
say 'START DATE 'start' FHR 'fhr'...'

say 'Opening Control files...'
say ' '
say ctl1
say ctl2

'open 'ctl1
'open 'ctl2

'set lon 'lon1' 'lon2
'set lat 'lat1' 'lat2

say 'Adjusting the resolution...'
result=sameres(1)
xres=subwrd(result,1)
yres=subwrd(result,2)

say 'New resolution:'
say 'x = 'xres'  y = 'yres

* MSLP Data file

say 'Appending to data files...'
say ' '


say 'MSLP...'

'define evar1=re2(PRMSLmsl.1/100,'xres','yres',bl)'
'define evar2=re2(PRMSLmsl.2/100,'xres','yres',bl)'
'define diff=evar2-evar1'

'd aave(diff,lon='lon1',lon='lon2',lat='lat1',lat='lat2')'
average=subwrd(result,4)

'd pow(aave(pow(evar2-evar1,2),lon='lon1',lon='lon2',lat='lat1',lat='lat2'),0.5)'
RMS=subwrd(result,4)

if(average = 'Operand' | RMS = 'Operand')
  say '-------------------------------------------------------------------------'
  say 'Error Calculating RMS or Bias for FHR 'fhr'. It could be a bad .ctl file.'
  say '-------------------------------------------------------------------------'
else
  write('MSLP_'start'.txt', ''fhr' 'average' 'RMS'',append)
endif

* Relative Humidity

say 'RH at levels 'level1'mb, 'level2'mb, and 'level3'mb...'

'set lev 'level1

'define evar1=re2(rhprs.1,'xres','yres',bl)'
'define evar2=re2(rhprs.2,'xres','yres',bl)'
'define diff=evar2-evar1'

'd aave(diff,lon='lon1',lon='lon2',lat='lat1',lat='lat2')'
average=subwrd(result,4)

'd pow(aave(pow(diff,2),lon='lon1',lon='lon2',lat='lat1',lat='lat2'),0.5)'
RMS=subwrd(result,4)

if(average = 'Operand' | RMS = 'Operand')
  say '-------------------------------------------------------------------------'
  say 'Error Calculating RMS or Bias for FHR 'fhr'. It could be a bad .ctl file.'
  say '-------------------------------------------------------------------------'
else
  write('rh_'level1'_'start'.txt', ''fhr' 'average' 'RMS'',append)
endif

***

'set lev 'level2

'define evar1=re2(rhprs.1,'xres','yres',bl)'
'define evar2=re2(rhprs.2,'xres','yres',bl)'
'define diff=evar2-evar1'

'd aave(diff,lon='lon1',lon='lon2',lat='lat1',lat='lat2')'
average=subwrd(result,4)

'd pow(aave(pow(diff,2),lon='lon1',lon='lon2',lat='lat1',lat='lat2'),0.5)'
RMS=subwrd(result,4)

if(average = 'Operand' | RMS = 'Operand')
  say '-------------------------------------------------------------------------'
  say 'Error Calculating RMS or Bias for FHR 'fhr'. It could be a bad .ctl file.'
  say '-------------------------------------------------------------------------'
else
  write('rh_'level2'_'start'.txt', ''fhr' 'average' 'RMS'',append)
endif


***

'set lev 'level3

'define evar1=re2(rhprs.1,'xres','yres',bl)'
'define evar2=re2(rhprs.2,'xres','yres',bl)'
'define diff=evar2-evar1'

'd aave(diff,lon='lon1',lon='lon2',lat='lat1',lat='lat2')'
average=subwrd(result,4)

'd pow(aave(pow(diff,2),lon='lon1',lon='lon2',lat='lat1',lat='lat2'),0.5)'
RMS=subwrd(result,4)

if(average = 'Operand' | RMS = 'Operand')
  say '-------------------------------------------------------------------------'
  say 'Error Calculating RMS or Bias for FHR 'fhr'. It could be a bad .ctl file.'
  say '-------------------------------------------------------------------------'
else
  write('rh_'level3'_'start'.txt', ''fhr' 'average' 'RMS'',append)
endif


********** TEMPERATURE AT 3 ATMOS LEVELS **********

say 'Temperature at levels 'level1'mb, 'level2'mb, and 'level3'mb...'

'set lev 'level1

'define evar1=re2(tmpprs.1,'xres','yres',bl)'
'define evar2=re2(tmpprs.2,'xres','yres',bl)'
'define diff=evar2-evar1'

'd aave(diff,lon='lon1',lon='lon2',lat='lat1',lat='lat2')'
average=subwrd(result,4)

'd pow(aave(pow(diff,2),lon='lon1',lon='lon2',lat='lat1',lat='lat2'),0.5)'
RMS=subwrd(result,4)

if(average = 'Operand' | RMS = 'Operand')
  say '-------------------------------------------------------------------------'
  say 'Error Calculating RMS or Bias for FHR 'fhr'. It could be a bad .ctl file.'
  say '-------------------------------------------------------------------------'
else
  write('tmp_'level1'_'start'.txt', ''fhr' 'average' 'RMS'',append)
endif

***

'set lev 'level2

'define evar1=re2(tmpprs.1,'xres','yres',bl)'
'define evar2=re2(tmpprs.2,'xres','yres',bl)'
'define diff=evar2-evar1'

'd aave(diff,lon='lon1',lon='lon2',lat='lat1',lat='lat2')'
average=subwrd(result,4)

'd pow(aave(pow(diff,2),lon='lon1',lon='lon2',lat='lat1',lat='lat2'),0.5)'
RMS=subwrd(result,4)

if(average = 'Operand' | RMS = 'Operand')
  say '-------------------------------------------------------------------------'
  say 'Error Calculating RMS or Bias for FHR 'fhr'. It could be a bad .ctl file.'
  say '-------------------------------------------------------------------------'
else
  write('tmp_'level2'_'start'.txt', ''fhr' 'average' 'RMS'',append)
endif

***

'set lev 'level3

'define evar1=re2(tmpprs.1,'xres','yres',bl)'
'define evar2=re2(tmpprs.2,'xres','yres',bl)'
'define diff=evar2-evar1'

'd aave(diff,lon='lon1',lon='lon2',lat='lat1',lat='lat2')'
average=subwrd(result,4)

'd pow(aave(pow(diff,2),lon='lon1',lon='lon2',lat='lat1',lat='lat2'),0.5)'
RMS=subwrd(result,4)

if(average = 'Operand' | RMS = 'Operand')
  say '-------------------------------------------------------------------------'
  say 'Error Calculating RMS or Bias for FHR 'fhr'. It could be a bad .ctl file.'
  say '-------------------------------------------------------------------------'
else
  write('tmp_'level3'_'start'.txt', ''fhr' 'average' 'RMS'',append)
endif

********** GEOPOTENTIAL HEIGHTS AT 3 ATMOS LEVELS **********

say 'GeoHeights at levels 'level1'mb, 'level2'mb, and 'level3'mb...'

'set lev 'level1

'define evar1=re2(hgtprs.1/10,'xres','yres',bl)'
'define evar2=re2(hgtprs.2/10,'xres','yres',bl)'
'define diff=evar2-evar1'

'd aave(diff,lon='lon1',lon='lon2',lat='lat1',lat='lat2')'
average=subwrd(result,4)

'd pow(aave(pow(diff,2),lon='lon1',lon='lon2',lat='lat1',lat='lat2'),0.5)'
RMS=subwrd(result,4)

if(average = 'Operand' | RMS = 'Operand')
  say '-------------------------------------------------------------------------'
  say 'Error Calculating RMS or Bias for FHR 'fhr'. It could be a bad .ctl file.'
  say '-------------------------------------------------------------------------'
else
  write('gph_'level1'_'start'.txt', ''fhr' 'average' 'RMS'',append)
endif

***

'set lev 'level2

'define evar1=re2(hgtprs.1/10,'xres','yres',bl)'
'define evar2=re2(hgtprs.2/10,'xres','yres',bl)'
'define diff=evar2-evar1'

'd aave(diff,lon='lon1',lon='lon2',lat='lat1',lat='lat2')'
average=subwrd(result,4)

'd pow(aave(pow(diff,2),lon='lon1',lon='lon2',lat='lat1',lat='lat2'),0.5)'
RMS=subwrd(result,4)

if(average = 'Operand' | RMS = 'Operand')
  say '-------------------------------------------------------------------------'
  say 'Error Calculating RMS or Bias for FHR 'fhr'. It could be a bad .ctl file.'
  say '-------------------------------------------------------------------------'
else
  write('gph_'level2'_'start'.txt', ''fhr' 'average' 'RMS'',append)
endif

***

'set lev 'level3

'define evar1=re2(hgtprs.1/10,'xres','yres',bl)'
'define evar2=re2(hgtprs.2/10,'xres','yres',bl)'
'define diff=evar2-evar1'

'd aave(diff,lon='lon1',lon='lon2',lat='lat1',lat='lat2')'
average=subwrd(result,4)

'd pow(aave(pow(diff,2),lon='lon1',lon='lon2',lat='lat1',lat='lat2'),0.5)'
RMS=subwrd(result,4)

if(average = 'Operand' | RMS = 'Operand')
  say '-------------------------------------------------------------------------'
  say 'Error Calculating RMS or Bias for FHR 'fhr'. It could be a bad .ctl file.'
  say '-------------------------------------------------------------------------'
else
  write('gph_'level3'_'start'.txt', ''fhr' 'average' 'RMS'',append)
endif

********** WINDS (AND COMPONENTS) AT 3 ATMOS LEVELS, AND AT 10 METERS FROM SURFACE **********

say 'Wind Speeds at levels 'level1'mb, 'level2'mb, and 'level3'mb, and 10m winds...'

'set lev 'level1

'define wspd1=mag(ugrdprs.1,vgrd10m.1)'
'define wspd2=mag(ugrdprs.2,vgrd10m.2)'

'define evar1=re2(wspd1,'xres','yres',bl)'
'define evar2=re2(wspd2,'xres','yres',bl)'
'define diff=evar2-evar1'

'd aave(diff,lon='lon1',lon='lon2',lat='lat1',lat='lat2')'
average=subwrd(result,4)

'd pow(aave(pow(diff,2),lon='lon1',lon='lon2',lat='lat1',lat='lat2'),0.5)'
RMS=subwrd(result,4)

if(average = 'Operand' | RMS = 'Operand')
  say '-------------------------------------------------------------------------'
  say 'Error Calculating RMS or Bias for FHR 'fhr'. It could be a bad .ctl file.'
  say '-------------------------------------------------------------------------'
else
  write('wind_'level1'_'start'.txt', ''fhr' 'average' 'RMS'',append)
endif

***

'define evar1=re2(ugrdprs.1,'xres','yres',bl)'
'define evar2=re2(ugrdprs.2,'xres','yres',bl)'
'define diff=evar2-evar1'

'd aave(diff,lon='lon1',lon='lon2',lat='lat1',lat='lat2')'
average=subwrd(result,4)

'd pow(aave(pow(diff,2),lon='lon1',lon='lon2',lat='lat1',lat='lat2'),0.5)'
RMS=subwrd(result,4)

if(average = 'Operand' | RMS = 'Operand')
  say '-------------------------------------------------------------------------'
  say 'Error Calculating RMS or Bias for FHR 'fhr'. It could be a bad .ctl file.'
  say '-------------------------------------------------------------------------'
else
  write('uwind_'level1'_'start'.txt', ''fhr' 'average' 'RMS'',append)
endif

***

'define evar1=re2(vgrdprs.1,'xres','yres',bl)'
'define evar2=re2(vgrdprs.2,'xres','yres',bl)'
'define diff=evar2-evar1'

'd aave(diff,lon='lon1',lon='lon2',lat='lat1',lat='lat2')'
average=subwrd(result,4)

'd pow(aave(pow(diff,2),lon='lon1',lon='lon2',lat='lat1',lat='lat2'),0.5)'
RMS=subwrd(result,4)

if(average = 'Operand' | RMS = 'Operand')
  say '-------------------------------------------------------------------------'
  say 'Error Calculating RMS or Bias for FHR 'fhr'. It could be a bad .ctl file.'
  say '-------------------------------------------------------------------------'
else
  write('vwind_'level1'_'start'.txt', ''fhr' 'average' 'RMS'',append)
endif

***

'set lev 'level2

'define wspd1=mag(ugrdprs.1,vgrd10m.1)'
'define wspd2=mag(ugrdprs.2,vgrd10m.2)'

'define evar1=re2(wspd1,'xres','yres',bl)'
'define evar2=re2(wspd2,'xres','yres',bl)'
'define diff=evar2-evar1'

'd aave(diff,lon='lon1',lon='lon2',lat='lat1',lat='lat2')'
average=subwrd(result,4)

'd pow(aave(pow(diff,2),lon='lon1',lon='lon2',lat='lat1',lat='lat2'),0.5)'
RMS=subwrd(result,4)

if(average = 'Operand' | RMS = 'Operand')
  say '-------------------------------------------------------------------------'
  say 'Error Calculating RMS or Bias for FHR 'fhr'. It could be a bad .ctl file.'
  say '-------------------------------------------------------------------------'
else
  write('wind_'level2'_'start'.txt', ''fhr' 'average' 'RMS'',append)
endif

***

'define evar1=re2(ugrdprs.1,'xres','yres',bl)'
'define evar2=re2(ugrdprs.2,'xres','yres',bl)'
'define diff=evar2-evar1'

'd aave(diff,lon='lon1',lon='lon2',lat='lat1',lat='lat2')'
average=subwrd(result,4)

'd pow(aave(pow(diff,2),lon='lon1',lon='lon2',lat='lat1',lat='lat2'),0.5)'
RMS=subwrd(result,4)

if(average = 'Operand' | RMS = 'Operand')
  say '-------------------------------------------------------------------------'
  say 'Error Calculating RMS or Bias for FHR 'fhr'. It could be a bad .ctl file.'
  say '-------------------------------------------------------------------------'
else
 write('uwind_'level2'_'start'.txt', ''fhr' 'average' 'RMS'',append)
endif

***

'define evar1=re2(vgrdprs.1,'xres','yres',bl)'
'define evar2=re2(vgrdprs.2,'xres','yres',bl)'
'define diff=evar2-evar1'

'd aave(diff,lon='lon1',lon='lon2',lat='lat1',lat='lat2')'
average=subwrd(result,4)

'd pow(aave(pow(diff,2),lon='lon1',lon='lon2',lat='lat1',lat='lat2'),0.5)'
RMS=subwrd(result,4)

if(average = 'Operand' | RMS = 'Operand')
  say 'Error Calculating RMS or Bias for FHR 'fhr'. It could be a bad .ctl file.'
else
 write('vwind_'level2'_'start'.txt', ''fhr' 'average' 'RMS'',append)
endif

***

'set lev 'level3

'define wspd1=mag(ugrdprs.1,vgrd10m.1)'
'define wspd2=mag(ugrdprs.2,vgrd10m.2)'

'define evar1=re2(wspd1,'xres','yres',bl)'
'define evar2=re2(wspd2,'xres','yres',bl)'
'define diff=evar2-evar1'

'd aave(diff,lon='lon1',lon='lon2',lat='lat1',lat='lat2')'
average=subwrd(result,4)

'd pow(aave(pow(diff,2),lon='lon1',lon='lon2',lat='lat1',lat='lat2'),0.5)'
RMS=subwrd(result,4)

if(average = 'Operand' | RMS = 'Operand')
  say '-------------------------------------------------------------------------'
  say 'Error Calculating RMS or Bias for FHR 'fhr'. It could be a bad .ctl file.'
  say '-------------------------------------------------------------------------'
else
  write('wind_'level3'_'start'.txt', ''fhr' 'average' 'RMS'',append)
endif

***

'define evar1=re2(ugrdprs.1,'xres','yres',bl)'
'define evar2=re2(ugrdprs.2,'xres','yres',bl)'
'define diff=evar2-evar1'

'd aave(diff,lon='lon1',lon='lon2',lat='lat1',lat='lat2')'
average=subwrd(result,4)

'd pow(aave(pow(diff,2),lon='lon1',lon='lon2',lat='lat1',lat='lat2'),0.5)'
RMS=subwrd(result,4)

if(average = 'Operand' | RMS = 'Operand')
  say '-------------------------------------------------------------------------'
  say 'Error Calculating RMS or Bias for FHR 'fhr'. It could be a bad .ctl file.'
  say '-------------------------------------------------------------------------'
else
  write('uwind_'level3'_'start'.txt', ''fhr' 'average' 'RMS'',append)
endif

***

'define evar1=re2(vgrdprs.1,'xres','yres',bl)'
'define evar2=re2(vgrdprs.2,'xres','yres',bl)'
'define diff=evar2-evar1'

'd aave(diff,lon='lon1',lon='lon2',lat='lat1',lat='lat2')'
average=subwrd(result,4)

'd pow(aave(pow(diff,2),lon='lon1',lon='lon2',lat='lat1',lat='lat2'),0.5)'
RMS=subwrd(result,4)

if(average = 'Operand' | RMS = 'Operand')
  say '-------------------------------------------------------------------------'
  say 'Error Calculating RMS or Bias for FHR 'fhr'. It could be a bad .ctl file.'
  say '-------------------------------------------------------------------------'
else
  write('vwind_'level3'_'start'.txt', ''fhr' 'average' 'RMS'',append)
endif

***

'define wspd1=mag(ugrd10m.1,vgrd10m.1)'
'define wspd2=mag(ugrd10m.2,vgrd10m.2)'

'define evar1=re2(wspd1,'xres','yres',bl)'
'define evar2=re2(wspd2,'xres','yres',bl)'
'define diff=evar2-evar1'

'd aave(diff,lon='lon1',lon='lon2',lat='lat1',lat='lat2')'
average=subwrd(result,4)

'd pow(aave(pow(diff,2),lon='lon1',lon='lon2',lat='lat1',lat='lat2'),0.5)'
RMS=subwrd(result,4)

if(average = 'Operand' | RMS = 'Operand')
  say 'Error Calculating RMS or Bias for FHR 'fhr'. It could be a bad .ctl file.'
else
  write('wind_10m_'start'.txt', ''fhr' 'average' 'RMS'',append)
endif

***

'define evar1=re2(ugrd10m.1,'xres','yres',bl)'
'define evar2=re2(ugrd10m.2,'xres','yres',bl)'
'define diff=evar2-evar1'

'd aave(diff,lon='lon1',lon='lon2',lat='lat1',lat='lat2')'
average=subwrd(result,4)

'd pow(aave(pow(diff,2),lon='lon1',lon='lon2',lat='lat1',lat='lat2'),0.5)'
RMS=subwrd(result,4)

if(average = 'Operand' | RMS = 'Operand')
  say 'Error Calculating RMS or Bias for FHR 'fhr'. It could be a bad .ctl file.'
else
  write('uwind_10m_'start'.txt', ''fhr' 'average' 'RMS'',append)
endif

***

'define evar1=re2(vgrd10m.1,'xres','yres',bl)'
'define evar2=re2(vgrd10m.2,'xres','yres',bl)'
'define diff=evar2-evar1'

'd aave(diff,lon='lon1',lon='lon2',lat='lat1',lat='lat2')'
average=subwrd(result,4)

'd pow(aave(pow(diff,2),lon='lon1',lon='lon2',lat='lat1',lat='lat2'),0.5)'
RMS=subwrd(result,4)

if(average = 'Operand' | RMS = 'Operand')
  say 'Error Calculating RMS or Bias for FHR 'fhr'. It could be a bad .ctl file.'
else
  write('vwind_10m_'start'.txt', ''fhr' 'average' 'RMS'',append)
endif


*******************************************************************************
function sameres(file)
*******************************************************************************
'q file 'file
i = 1
while (i<100)
  xsize = subwrd(result,i)
  if(xsize=Xsize)
    xres1 = subwrd(result,i+2)
    i = 100
  endif
  i = i+1
endwhile

'q file 'file
i = 1
while (i<100)
  ysize = subwrd(result,i)
  if(ysize=Ysize)
    yres1 = subwrd(result,i+2)
    i = 100
  endif
  i = i+1
endwhile

**Convert to degrees (lat-lon)**
'q dims'
i = 1
while(i<100)
  lonx = subwrd(result,i)
  latx = subwrd(result,i)
  if(lonx=Lon)
    lon1=subwrd(result,i+2)
    lon2=subwrd(result,i+4)
  endif
  if(latx=Lat)
    lat1=subwrd(result,i+2)
    lat2=subwrd(result,i+4)
    i = 100
  endif
  i = i+1
endwhile

lat1=lat2-lat1
lon1=lon2-lon1
xres=lon1/xres1
yres=lat1/yres1

return xres " " yres

