* Line graph creator for MSLP (for MPlot)
* Created by: Bryan M. Williams on September 1,3 2013

Function main(args)
run1=subwrd(args,1)
run2=subwrd(args,2)
run3=subwrd(args,3)
run4=subwrd(args,4)
start_date=subwrd(args,5)
xint=subwrd(args,6)
xmax=subwrd(args,7)

* Pre-Script Tasks

'reinit'
'set display color white'
'c'

*'!mkdir graphs'

* Set dimensions.

pxlo=1.3
pxhi=9
pylo=1.5
pyhi=7.5

** LEGEND DIMENSIONS **

pxlo_l=9.2
pxhi_l=10.9
pylo_l=4.2
pyhi_l=5.5

yint=0.1
xlab='Forecast Hour'
ylab='Error (hPa)'
title1='MSLP RMS'
title2=start_date

marktype1=2
marksize1=0.09
lcolor1=2
lstyle1=1
lthick1=6

marktype2=8
marksize2=0.09
lcolor2=5
lstyle2=1
lthick2=6

marktype3=8
marksize3=0.09
lcolor3=4
lstyle3=1
lthick3=6

xmin=0

* Draw Graph Area.

say 'Drawing graph area...'

'set parea 'pxlo' 'pxhi' 'pylo' 'pyhi
'set ccolor 1'
'set line 1 1 4'
'draw line 'pxlo' 'pylo' 'pxhi' 'pylo
'draw line 'pxhi' 'pylo' 'pxhi' 'pyhi
'draw line 'pxhi' 'pyhi' 'pxlo' 'pyhi
'draw line 'pxlo' 'pyhi' 'pxlo' 'pylo

xdif = (pxhi - pxlo)/(xmax - xmin)

* Set up axes.

* * Y-axis

* Determine min and max.

say 'Determining values for y-axis...'

rc=0
ymin=0
ymax=0
res=read('MSLP_'start_date'_RMS_triple.txt')
rc=sublin(res,1)
first=1
while(rc=0)
  yval=subwrd(res,3)
  if(ymax < yval)
    ymax=yval
  endif
  if(yval < ymin)
    ymin=yval
  endif

  if(first)
    ymin=yval
    ymax=yval
    first=0
  endif

  yval=subwrd(res,4)
  if(ymax < yval)
    ymax=yval
  endif
  if(yval < ymin)
    ymin=yval
  endif

  yval=subwrd(res,5)
  if(ymax < yval)
    ymax=yval
  endif
  if(yval < ymin)
    ymin=yval
  endif

  
  res=read('MSLP_'start_date'_RMS_triple.txt')
  rc=sublin(res,1)
  if(rc != 0)
    if(rc = 2)
*     say 'Determining axis bounds: End of file reached.'
*     say ' '
      break
    else
      say 'CRITICAL! Error code 'rc'.'
      return
    endif
  endif
endwhile

res=close('MSLP_'start_date'_RMS_triple.txt')

if(ymin < 0 | ymin > 1)
  ymin=math_format('%.1f',ymin) - 0.1
endif

if(ymin > 0 & ymin < 1)
  ymin=0
endif

ymax=math_format('%.2f',ymax) + 0.1

ydif = (pyhi - pylo)/(ymax - ymin)

if(ymin < 0 & ymax > 0)
  zero=pylo+(0-ymin)*ydif
  'set rgb 20 200 200 200'
  'set line 20 4 1'
  'draw line 'pxlo' 'zero' 'pxhi' 'zero
  'set string 20'
  'draw string 'pxlo+0.05' 'zero+0.05' 0.00'
  'draw string 'pxhi-0.40' 'zero+0.05' 0.00'
  'set string 1'
  'set line 1 1 1'
endif

say 'Creating y-axis...'

num=math_abs((ymax-ymin)/ yint)
num=math_format('%.0f',num)
say 'Initial number of y labels, according to yint: 'num

if(num > 15)
 say 'The y-axis has too many labels! Max number is 15. Increasing yint by increments of 'yint*2'...'
 while(num > 15)
   yint=yint*2
   num=math_abs((ymax-ymin) / yint)
   num=math_format('%.0f',num)
   if(num <= 15)
     say 'Done. New yint is: 'yint
   endif
 endwhile
else
  say 'Number of y-axis labels are at or below the maximum of 15. Continuing...'
endif

yy = ymin
'set string 1 r 2 0'
'set strsiz 0.10 0.12'
while (yy<=ymax & yy>=ymin)
y = pylo+(yy-ymin)*ydif
xa=pxlo-0.09
xl=pxlo-0.1
'draw line 'xa' 'y' 'pxlo' 'y
rc = math_format('%.2f',yy)
'draw string 'xl' 'y' 'rc
yy = yy + yint
endwhile


* * X-axis

say 'Creating X-axis (FHR)...'

oldlbl=0
lbl=0

xx = xmin
'set string 1 bc 2 70'
'set strsiz 0.10 0.12'
res = read('MSLP_'start_date'_RMS_triple.txt')
rc = sublin(res,1)

while (xx<=xmax & xx>=xmin & rc=0)
  line = sublin(res,2)
  if(lbl >= oldlbl)
    lbl=subwrd(res,2)
    x=pxlo+(xx-xmin)*xdif
    ya=pylo-0.04
    y=pylo-0.23
    say 'plotting... 'lbl
    'draw line 'x' 'pylo' 'x' 'ya
    if(xint < 6)
      if(math_fmod(lbl,6) = 0)
        'draw string 'x' 'y' 'lbl
      endif
    endif
    if(xint >= 6)
      'draw string 'x' 'y' 'lbl
    endif
    xx = xx + xint
    oldlbl = lbl
  endif
  lasthr=subwrd(res,2) 
  res = read('MSLP_'start_date'_RMS_triple.txt')
  rc = sublin(res,1)
  if(rc != 0)
*   say 'Return Code: 'rc
*   say 'End of file reached.'
    say ' '
    break
  endif
* say 'Return Code: 'rc
endwhile

res = close('MSLP_'start_date'_RMS_triple.txt')

* Graph Forecast hour vs. area average.

say 'Drawing Graph...'

first=0
res = read('MSLP_'start_date'_RMS_triple.txt')
rc = sublin(res,1)

while (rc=0)

  fhr = subwrd(res,2)
  arms1 = subwrd(res,3)
  arms2 = subwrd(res,4)
  arms3 = subwrd(res,5) 
 
  x = fhr
  y1 = arms1
  y2 = arms2
  y3 = arms3

  x = pxlo+(x-xmin)*xdif
  y1 = pylo+(y1-ymin)*ydif
  y2 = pylo+(y2-ymin)*ydif
  y3 = pylo+(y3-ymin)*ydif

  'set line 'lcolor1' 'lstyle1' 'lthick1
* 'draw mark 'marktype1' 'x' 'y1' 'marksize1

  'set line 'lcolor2' 'lstyle2' 'lthick2
* 'draw mark 'marktype2' 'x' 'y2' 'marksize2

  'set line 'lcolor3' 'lstyle3' 'lthick3
* 'draw mark 'marktype3' 'x' 'y3' 'marksize3

  if(first)
    'set line 'lcolor1' 'lstyle1' 'lthick1
    'draw line 'xold' 'y1old' 'x' 'y1
    
    'set line 'lcolor2' 'lstyle2' 'lthick2
    'draw line 'xold' 'y2old' 'x' 'y2

    'set line 'lcolor3' 'lstyle3' 'lthick3
    'draw line 'xold' 'y3old' 'x' 'y3
  endif

  first = 1

  xold = x
  y1old = y1
  y2old = y2
  y3old = y3

  res = read('MSLP_'start_date'_RMS_triple.txt')

  rc = sublin(res,1)

endwhile

*** Create a legend (key), x- and y-axis label, and title. ***

* Legend (Key)

* Draw box where key will go.

int=0.2

'set parea 'pxlo_l' 'pxhi_l' 'pylo_l' 'pyhi_l
'set ccolor 1'
'set line 1 1 4'
'draw line 'pxlo_l' 'pylo_l' 'pxhi_l' 'pylo_l
'draw line 'pxhi_l' 'pylo_l' 'pxhi_l' 'pyhi_l
'draw line 'pxhi_l' 'pyhi_l' 'pxlo_l' 'pyhi_l
'draw line 'pxlo_l' 'pyhi_l' 'pxlo_l' 'pylo_l

* Draw lines and marks.

starty=pyhi_l-0.2
startx=pxlo_l+0.2

'set string 1 bl 0 0'

'set line 'lcolor1' 'lstyle1' 'lthick1
'draw line 'startx' 'starty' 'startx+0.3' 'starty
'set line 'lcolor1' 'lstyle1' 'lthick1
*'draw mark 'marktype1' 'startx+0.15' 'starty' 'marksize1
'draw string 'startx+0.40' 'starty-0.05' Control'

'set line 'lcolor2' 'lstyle2' 'lthick2
'draw line 'startx' 'starty-0.4' 'startx+0.3' 'starty-0.4
'set line 'lcolor2' 'lstyle2' 'lthick2
*'draw mark 'marktype2' 'startx+0.15' 'starty-0.4' 'marksize2
'draw string 'startx+0.40' 'starty-0.45' Ctrl+OAWL'

'set line 'lcolor3' 'lstyle3' 'lthick3
'draw line 'startx' 'starty-0.8' 'startx+0.3' 'starty-0.8
'set line 'lcolor3' 'lstyle3' 'lthick3
*'draw mark 'marktype3' 'startx+0.15' 'starty-0.4' 'marksize3
'draw string 'startx+0.40' 'starty-0.85' Ctrl+WISSCR'

'set string 1 c 1 0'
'draw string 'pxlo_l+0.8' 'pyhi_l+0.2' KEY'

* Draw Titles and axes labels.

* X-axis label

'set strsiz 0.2'
'set string 1 c 10 0'
'draw string 5.8 0.5 'xlab

* Y-axis label

'set strsiz 0.2'
'set string 1 c 10 90'
'draw string 0.3 4 'ylab

* Title
'set strsiz 0.2'
'set string 1 c 10 0'
'draw string 5.8 8.3 'title1
'draw string 5.8 7.9 'title2


'printim mslp_error_'start_date'_triple.png x1600 y1200'
 

say 'Done. Graph completed.'
