#!/bin/csh 

set start=$1
set fhr=$2
set step=$3

set halfint=0

if( -d NR_ctl ) then
   echo
else
  mkdir NR_ctl
endif

if( -d CTL_logfiles ) then
  echo
else
  mkdir CTL_logfiles
endif

set dir=`pwd`

source $dir/config

set chr=0

while($fhr >= $chr)
  if($halfint == 1) then
    set date=`./timestring.sh $start $chr`
    echo $date'00' >> datelist.txt
    echo $date'30' >> datelist.txt
  else
    set date=`./timestring.sh $start $chr`
    echo $date'00' >> datelist.txt
  endif
  @ chr=$chr + $step
end

foreach line ("`cat datelist.txt`")
  echo ${NR_type}${line} >> filelist.txt
end

foreach file ("`cat filelist.txt`")
   echo "Making control and index file for NR time "$line"..."
  ./grib2ctl -verf $ROOT_NR/$file ./$file.idx >> $file.ctl
  gribmap -v -i $file.ctl >> log_${file}_gribmap.txt
end

mv *.idx NR_ctl
mv *.ctl NR_ctl
mv log_* CTL_logfiles

rm filelist.txt
rm datelist.txt

exit 0
