* Line graph creator for MSLP (for MPlot)
* Created by: Bryan M. Williams on September 13 2013

Function main(args)
domain=subwrd(args,1)
xmin=subwrd(args,2)
xint=subwrd(args,3)
xmax=subwrd(args,4)

* Pre-Script Tasks

*'reinit'
*'set display color white'
*'c'

*'!mkdir graphs'

* Set dimensions.

pxlo=1.3
pxhi=6.6
pylo=3.1
pyhi=7.5

** LEGEND DIMENSIONS **

pxlo_l=9.2
pxhi_l=10.9
pylo_l=4.7
pyhi_l=5.5

yint=0.1
xlab='Forecast Hour'
ylab='Error (hPa)'
title1='MSLP Domain Averages'
title2='Mean (red) and RMS (blue)'

AVGmarktype=2
AVGmarksize=0.09
AVGlcolor=2
AVGlstyle=1
AVGlthick=6

RMSmarktype=8
RMSmarksize=0.09
RMSlcolor=4
RMSlstyle=1
RMSlthick=6

*xmin=0
*xmax=60
*ymin=-1.5
*ymax=1.5

*say ' '
*say 'This is the Line Graph for abs. mean of MSLP for date 'start_date'.'
*say '-------------------------------------------------------------------'
*say ' '

* Draw Graph Area.

say 'Drawing graph area...'

'set parea 'pxlo' 'pxhi' 'pylo' 'pyhi
'set ccolor 1'
'set line 1 1 4'
'draw line 'pxlo' 'pylo' 'pxhi' 'pylo
'draw line 'pxhi' 'pylo' 'pxhi' 'pyhi
'draw line 'pxhi' 'pyhi' 'pxlo' 'pyhi
'draw line 'pxlo' 'pyhi' 'pxlo' 'pylo

xdif = (pxhi - pxlo)/(xmax - xmin)

* Set up axes.

* * Y-axis

* Determine min and max.

say 'Determining values for y-axis...'

rc=0
ymin=-1000
ymax=1000
res=read('MSLP_da_d0'domain'.txt')
rc=sublin(res,1)
first=1
while(rc=0)
  yval=subwrd(res,3)
  if(ymax < yval)
    ymax=yval
  endif
  if(yval < ymin)
    ymin=yval
  endif

  if(first)
    ymin=yval
    ymax=yval
    first=0
  endif

  yval=subwrd(res,4)
  if(ymax < yval)
    ymax=yval
  endif
  if(yval < ymin)
    ymin=yval
  endif
  
  res=read('MSLP_da_d0'domain'.txt')
  rc=sublin(res,1)
  if(rc != 0)
    if(rc = 2)
*     say 'Determining axis bounds: End of file reached.'
*     say ' '
      break
    else
      say 'CRITICAL! Error code 'rc'.'
      return
    endif
  endif
endwhile

res=close('MSLP_da_d0'domain'.txt')

if(ymin < 0 | ymin > 1)
  ymin=math_format('%.1f',ymin) - 1
endif

if(ymin > 0 & ymin < 1)
  ymin=0
endif

ymax=math_format('%.2f',ymax) + 1

ymin=-20
ymax=20
yint=4

ydif = (pyhi - pylo)/(ymax - ymin)

if(ymin < 0 & ymax > 0)
  zero=pylo+(0-ymin)*ydif
  'set rgb 20 200 200 200'
  'set line 20 4 1'
  'draw line 'pxlo' 'zero' 'pxhi' 'zero
  'set string 20 bl 2 0'
  'set strsiz 0.10 0.12'
  'draw string 'pxlo+0.05' 'zero+0.05' 0.00'
  'draw string 'pxhi-0.40' 'zero+0.05' 0.00'
  'set string 1'
  'set line 1 1 1'
endif

say 'Creating y-axis...'

num=math_abs((ymax-ymin)/ yint)
num=math_format('%.0f',num)
say 'Initial number of y labels, according to yint: 'num

if(num > 15)
 say 'The y-axis has too many labels! Max number is 15. Increasing yint by increments of 'yint*2'...'
 while(num > 15)
   yint=yint*2
   num=math_abs((ymax-ymin) / yint)
   num=math_format('%.0f',num)
   if(num <= 15)
     say 'Done. New yint is: 'yint
   endif
 endwhile
else
  say 'Number of y-axis labels are at or below the maximum of 15. Continuing...'
endif

yy = ymin
'set string 1 r 2 0'
'set strsiz 0.10 0.12'
while (yy<=ymax & yy>=ymin)
y = pylo+(yy-ymin)*ydif
xa=pxlo-0.09
xl=pxlo-0.1
'draw line 'xa' 'y' 'pxlo' 'y
rc = math_format('%.2f',yy)
'draw string 'xl' 'y' 'rc
yy = yy + yint
endwhile


* * X-axis

say 'Creating X-axis (FHR)...'

oldlbl=0
lbl=0

xx = xmin
'set string 1 bc 2 70'
'set strsiz 0.10 0.12'
res = read('MSLP_da_d0'domain'.txt')
rc = sublin(res,1)

while (xx<=xmax & xx>=xmin & rc=0)
  line = sublin(res,2)
  if(lbl >= oldlbl)
    lbl=subwrd(res,2)
    x=pxlo+(xx-xmin)*xdif
    ya=pylo-0.04
    y=pylo-0.23
*   say 'plotting... 'lbl
    'draw line 'x' 'pylo' 'x' 'ya
    if(xint < 6)
      if(math_fmod(lbl,6) = 0)
        'draw string 'x' 'y' 'lbl
      endif
    endif
    if(xint >= 6)
      'draw string 'x' 'y' 'lbl
    endif
    xx = xx + xint
    oldlbl = lbl
  endif
  lasthr=subwrd(res,2) 
  res = read('MSLP_da_d0'domain'.txt')
  rc = sublin(res,1)
  if(rc != 0)
*   say 'Return Code: 'rc
*   say 'End of file reached.'
    say ' '
    break
  endif
* say 'Return Code: 'rc
endwhile

res = close('MSLP_da_d0'domain'.txt')

* Graph Forecast hour vs. area average.

say 'Drawing Graph...'

first=0
res = read('MSLP_da_d0'domain'.txt')
rc = sublin(res,1)

while (rc=0)

  fhr = subwrd(res,2)
  aavg = subwrd(res,3)
  arms = subwrd(res,4)

  x = fhr
  y1 = aavg
  y2 = arms

  x = pxlo+(x-xmin)*xdif
  y1 = pylo+(y1-ymin)*ydif
  y2 = pylo+(y2-ymin)*ydif

  'set line 'AVGlcolor' 'AVGlstyle' 'AVGlthick
* 'draw mark 'AVGmarktype' 'x' 'y1' 'AVGmarksize

  'set line 'RMSlcolor' 'RMSlstyle' 'RMSlthick
* 'draw mark 'RMSmarktype' 'x' 'y2' 'RMSmarksize

  if(first)
    'set line 'AVGlcolor' 'AVGlstyle' 'AVGlthick
    'draw line 'xold' 'y1old' 'x' 'y1
    
    'set line 'RMSlcolor' 'RMSlstyle' 'RMSlthick
    'draw line 'xold' 'y2old' 'x' 'y2
  endif

  first = 1

  xold = x
  y1old = y1
  y2old = y2

  res = read('MSLP_da_d0'domain'.txt')

  rc = sublin(res,1)

endwhile

mid=(pxhi+pxlo)/2
midy=(pyhi+pylo)/2

* X-axis label

'set strsiz 0.2'
'set string 1 c 10 0'
'draw string 'mid' 2.5 'xlab

* Y-axis label

'set strsiz 0.2'
'set string 1 c 10 90'
'draw string 0.5 'midy' 'ylab

* Title
'set strsiz 0.2'
'set string 1 c 10 0'
'draw string 'mid' 8.3 'title1
'draw string 'mid' 7.9 'title2

* 'draw string 8.5 0.3 Area RMS = 'arms

return

*** Create a legend (key), x- and y-axis label, and title. ***

* Legend (Key)

* Draw box where key will go.

int=0.2

'set parea 'pxlo_l' 'pxhi_l' 'pylo_l' 'pyhi_l
'set ccolor 1'
'set line 1 1 4'
'draw line 'pxlo_l' 'pylo_l' 'pxhi_l' 'pylo_l
'draw line 'pxhi_l' 'pylo_l' 'pxhi_l' 'pyhi_l
'draw line 'pxhi_l' 'pyhi_l' 'pxlo_l' 'pyhi_l
'draw line 'pxlo_l' 'pyhi_l' 'pxlo_l' 'pylo_l

* Draw lines and marks.

starty=pyhi_l-0.2
startx=pxlo_l+0.2

'set string 1 bl 0 0'

'set line 'AVGlcolor' 'AVGlstyle' 'AVGlthick
'draw line 'startx' 'starty' 'startx+0.3' 'starty
'set line 'AVGlcolor' 'AVGlstyle' 'AVGlthick
'draw mark 'AVGmarktype' 'startx+0.15' 'starty' 'AVGmarksize
'draw string 'startx+0.40' 'starty-0.05' Mean'

'set line 'RMSlcolor' 'RMSlstyle' 'RMSlthick
'draw line 'startx' 'starty-0.4' 'startx+0.3' 'starty-0.4
'set line 'RMSlcolor' 'RMSlstyle' 'RMSlthick
'draw mark 'RMSmarktype' 'startx+0.15' 'starty-0.4' 'RMSmarksize
'draw string 'startx+0.40' 'starty-0.45' RMS'

'set string 1 c 1 0'
'draw string 'pxlo_l+0.8' 'pyhi_l+0.2' KEY'

* Draw Titles and axes labels.

* X-axis label

'set strsiz 0.2'
'set string 1 c 10 0'
'draw string 5.8 0.5 'xlab

* Y-axis label

'set strsiz 0.2'
'set string 1 c 10 90'
'draw string 0.3 4 'ylab

* Title
'set strsiz 0.2'
'set string 1 c 10 0'
'draw string '(pxhi-pxlo)/2' 8.3 'title1
'draw string '(pxhi-pxlo)/2' 7.9 'title2


'printim mslp_error_'start_date'.png x1600 y1200'
 

say 'Done. Graph completed.'
