## Graphics Master Script v. 1.0
## Created by Bryan M. Williams on January 24, 2014



import time as t
import sys as s
import os, re, shutil
import subprocess as proc

def datestring(date): ## Function to convert date list into a string
	stryear = str(date[0])

	if len(str(date[1])) == 1: ## add 0 if month is earlier than 10 [October]
		strmon = '0' + str(date[1])
	else:
		strmon = str(date[1])

	if len(str(date[2])) == 1: ## add 0 if day is less than 10
		strday = '0' + str(date[2])
	else:
		strday = str(date[2])

	if len(str(date[3])) == 1: ## Add 0 if hour is less than 10
		strhour = '0' + str(date[3])
	else:
		strhour = str(date[3])

	strdate = stryear + strmon + strday + strhour # Create string and return.
	return strdate

def findlastday(year, mon): ## Function to find the last day of a month.
	mon30 = [4, 6, 9, 11] ## Months with 30 days: 4 [April], 6 [June], 9 [September], 11 [November]
	lastday = 0

	for M in mon30:
        	if int(mon) == M:
#               	print "30 day mon."
                	lastday = 30
                	break

	if lastday == 0 and mon != 2:
#       	print "31-day mon."
        	lastday = 31

	if int(mon) == 2: # Leap year checker if mon = 2 [February]
        	if int(year) % 4 == 0:
#               	print "The mon of February...leap year."
                	lastday = 29
        	else:
#               	print "The mon of February...not leap year."
                	lastday = 28
	return lastday


def datelistgen(range, step): ## Function to generate a list of dates.
	L = []
	L = range.split('-')
	startdate = L[0]
	enddate = L[1]
#	print 'Start Date: ' + str(startdate) + '; End date: ' + str(enddate)

	## Parse the dates into its components: year, month, day, hour. Create a list with these components.
	
	styear = startdate[0:4]
	stmon = startdate[4:6]
	stday = startdate[6:8]
	sthour = startdate[8:]

	enyear = enddate[0:4]
	enmon = enddate[4:6]
	enday = enddate[6:8]
	enhour = enddate[8:]

	st_year = int(styear)
	st_mon = int(stmon)
	st_day = int(stday)
	st_hour = int(sthour)

	en_year = int(enyear)
	en_mon = int(enmon)
	en_day = int(enday)
	en_hour = int(enhour)

	st_date = [st_year, st_mon, st_day, st_hour]
	en_date = [en_year, en_mon, en_day, en_hour]

	## Generate list of datelist days.

	datelist = []

	datelist.append(startdate)
	curdate = startdate
	in_date = st_date

	in_year = in_date[0]
	in_mon = in_date[1]
	in_day = in_date[2]
	in_hour = in_date[3]

	while curdate != enddate:

        	lastday = findlastday(in_year, in_mon)
        	in_hour = in_hour + int(step)

        	if in_hour >= 24:
                	in_hour = in_hour - 24
                	in_day = in_day + 1

        	if in_day > lastday:
                	in_day = in_day - lastday
                	in_mon = in_mon + 1

        	in_date[1] = in_mon
        	in_date[2] = in_day
        	in_date[3] = in_hour

        	datelist.append(datestring(in_date))
        	curdate = datestring(in_date)

	return datelist ## Return the date list to the main script.

def datedecoder(path, date): ## Function to insert dates into map config directory to insert into the bash script's config.
#	print path

	year = date[0:4]
	mon = date[4:6]
	day = date[6:8]
	hour = date[8:]

	## First, replace 'YYYY' with the year.

	A = path.find('YYYY')
	while A != -1:
		B = A + 4
		path = path[:A] + str(year) + path[B:]
		A = path.find('YYYY')

	## Next, add the month (MM).

	A = path.find('MM')
	while A != -1:
		B = A + 2
		path = path[:A] + str(mon) + path[B:]
		A = path.find('MM')

	## Next, add the day (DD).

	A = path.find('DD')
	while A != -1:
		B = A + 2
                path = path[:A] + str(day) + path[B:]
                A = path.find('DD')

	## Finally, add the hour (HH).

        A = path.find('HH')
        while A != -1:
                B = A + 2
                path = path[:A] + str(hour) + path[B:]
                A = path.find('HH')

	## Return result to main script.

	return path

def domaindecoder(path, domain): ## Function to insert domain into path.
	A = path.find('ddd')

	if len(str(domain)) == 1:
		dtext = 'd0' + str(domain)
	else:
		dtext = 'd' + str(domain)

	while A != -1:
		B = A + 3
		path = path[:A] + dtext + path[B:]
		A = path.find('ddd')

	return path

def configcreator(root1, root_type, root_end, title, level1, level2, level3): ## Function to create a new config file
	output = open('new_config', 'w')

	for line in open('config'):
        	linelist = line.split(' ')
        	try:
                	if linelist[1] == 'ROOT_TYPE':
                        	output.write('setenv ROOT_TYPE ' + str(root_type) + '\n')
                	elif linelist[1] == 'ROOT1':
                        	output.write('setenv ROOT1 ' + str(root1) + '\n\n')
                	elif linelist[1] == 'ROOT_END':
                        	output.write('setenv ROOT_END ' + str(root_end) + '\n\n')
			elif linelist[1] == 'title':
				output.write('setenv title ' + str(title) + '\n\n')
			elif linelist[1] == 'level1':
				output.write('setenv level1 ' + str(level1) + '\n\n')
			elif linelist[1] == 'level2':
				output.write('setenv level2 ' + str(level2) + '\n\n')
			elif linelist[1] == 'level3':
				output.write('setenv level3 ' + str(level3) + '\n\n')
                	else:
                        	output.write(line + '\n')
        	except:
                	continue

	output.close()
	try:
		os.remove('./config')
		os.rename('./new_config', './config')
	except:
		os.rename('./new_config', './config')

def da_configcreator(run, level1, level2, level3, domain): ## Function to create a new config file for domain average calcs.
	output = open('new_da_config', 'w')

	for line in open('da_config'):
		linelist = line.split(' ')
		try:
			if linelist[1] == 'run':
				output.write('setenv run ' + str(run) + '\n\n')
			elif linelist[1] == 'level1':
				output.write('setenv level1 ' + str(level1) + '\n\n')
			elif linelist[1] == 'level2':
                                output.write('setenv level2 ' + str(level2) + '\n\n')
                        elif linelist[1] == 'level3':
                                output.write('setenv level3 ' + str(level3) + '\n\n')
			elif linelist[1] == 'domain':
				output.write('setenv domain ' + str(domain) + '\n\n')
                        else:
                                output.write(line + '\n')
                except:
                        continue

def errorlog(title, path, errno, numerr): ## Function to write error logs to file.
	out = open('maps_master_log.txt', 'a')

        TM = t.localtime()

        if len(str(TM[3])) == 1:
                hour = '0' + str(TM[3])
        else:
                hour = str(TM[3])

        if len(str(TM[4])) == 1:
                minute = '0' + str(TM[4])
        else: 
                minute = str(TM[4])
 
        if len(str(TM[5])) == 1:
                second = '0' + str(TM[5])
        else:
                second = str(TM[5])

        TMstring = str(TM[1]) + '/' + str(TM[2]) + '/' + str(TM[0]) + ' ' + str(hour) + ':' + str(minute) + ':' + str(second)

	out.write('-----ERROR LOG REPORT...#' + str(numerr) + '...-----\n\n')
	out.write('Timestamp: ' + str(TMstring) + '\n')
	out.write('Run name: ' + str(title) + '\n')
	out.write('Run path: ' + str(path) + '\n')
	out.write('Error Code provided by wrfout_process.sh: ' + str(errno) + '\n\n')

##	Error descriptions below here...

	if int(errno) == 1:
		out.write('Error Description: A required GRIB file was not found in the directory. Please check the directory.\n\n')
	elif int(errno) == 2:
		out.write('Error Description: Starting hour is greater than the ending hour. Check configs.\n\n')
	elif int(errno) == 3:
		out.write('Error Description: Time Increment is greater than the final forecast hour. Check configs.\n\n')

	else: ## When all options are exhausted...
		out.write('Error Description: Unknown.\n\n')

##	Error report footer...and then close the file.

	out.write('-----END ERROR REPORT...-----\n\n')

	out.close()

def logheader(): ## Function to write the log header at the start of the script.
	out = open('maps_master_log.txt', 'a')

        TM = t.localtime()

        if len(str(TM[3])) == 1:
                hour = '0' + str(TM[3])
        else:
                hour = str(TM[3])

        if len(str(TM[4])) == 1:
                minute = '0' + str(TM[4])
        else: 
                minute = str(TM[4])
 
        if len(str(TM[5])) == 1:
                second = '0' + str(TM[5])
        else:
                second = str(TM[5])

        TMstring = str(TM[1]) + '/' + str(TM[2]) + '/' + str(TM[0]) + ' ' + str(hour) + ':' + str(minute) + ':' + str(second)

	out.write('\n\n-----LOG FOR MAP MASTER...STARTED ON ' + str(TMstring) + '-----\n\n')

	out.close()

def logfooter(numerr): ## Function to add footer to log.
	out = open('maps_master_log.txt', 'a')

        TM = t.localtime()

        if len(str(TM[3])) == 1:
                hour = '0' + str(TM[3])
        else:
                hour = str(TM[3])

        if len(str(TM[4])) == 1:
                minute = '0' + str(TM[4])
        else: 
                minute = str(TM[4])
 
        if len(str(TM[5])) == 1:
                second = '0' + str(TM[5])
        else:
                second = str(TM[5])

        TMstring = str(TM[1]) + '/' + str(TM[2]) + '/' + str(TM[0]) + ' ' + str(hour) + ':' + str(minute) + ':' + str(second)

	if numerr > 0:
		if numerr == 1:
			out.write(str(numerr) + ' error occured in total.\n\n')
		else:
			out.write(str(numerr) + ' errors occured in total.\n\n')
	else:
		out.write('No errors occured.\n\n')
	
	out.write('\n\n-----END MAP MASTER LOG... FINISHED ON ' + str(TMstring) + '-----\n\n')

	out.close()

def errorlogother(errno): ## Function to write error logs for script-killing errors.
	out = open('maps_master_log.txt', 'a')

        TM = t.localtime()

        if len(str(TM[3])) == 1:
                hour = '0' + str(TM[3])
        else:
                hour = str(TM[3])

        if len(str(TM[4])) == 1:
                minute = '0' + str(TM[4])
        else: 
                minute = str(TM[4])
 
        if len(str(TM[5])) == 1:
                second = '0' + str(TM[5])
        else:
                second = str(TM[5])

        TMstring = str(TM[1]) + '/' + str(TM[2]) + '/' + str(TM[0]) + ' ' + str(hour) + ':' + str(minute) + ':' + str(second)

	if errno == 101:
		out.write('CRITICAL ERROR: MISMATCHED KEYS.\n\n')
	elif errno == 102:
		out.write('CRITICAL ERROR: WRFOUT_PROCESS.SH NOT FOUND.\n\n')
	else:
		out.write('CRITICAL ERROR: UNKNOWN ERROR. (Code ' + str(errno) + ')\n\n')

	out.close()

def logfootererror(errno): # Function to create footers for errors that cause script to kill itself midway.
	out.open('maps_master_log.txt', 'a')

        TM = t.localtime()

        if len(str(TM[3])) == 1:
                hour = '0' + str(TM[3])
        else:
                hour = str(TM[3])

        if len(str(TM[4])) == 1:
                minute = '0' + str(TM[4])
        else:
                minute = str(TM[4])

        if len(str(TM[5])) == 1:
                second = '0' + str(TM[5])
        else:
                second = str(TM[5])

        TMstring = str(TM[1]) + '/' + str(TM[2]) + '/' + str(TM[0]) + ' ' + str(hour) + ':' + str(minute) + ':' + str(second)

	out.write('FATAL ERRORS OCCURED. SEE ABOVE LOG.\n\n')
	out.write('\n\n-----END MAP MASTER LOG... FINISHED ON ' + str(TMstring) + '-----\n\n')

	out.close()

def logexp(exp):
	out = open('maps_master_log.txt', 'a')
	out.write('Experiment name: ' + str(exp) + '\n')
	out.close()

def loggen(start, rc):
	out = open('maps_master_log.txt', 'a')

	if rc == 0:
		out.write('Date ' + str(start) + ': OK\n')
	else:
		out.write('Date ' + str(start) + ': Errors occured. See above.\n')

	out.close()

def da_check(da, rc):
	out = open('maps_master_log.txt', 'a')

	if da:
		if rc == 0:
			out.write('Domain Averages WAS run sucessfully.\n\n')
		else:
			out.write('Domain Averages WAS run, however, errors occured. (Code ' + str(rc) + ')\n\n')
	else:
		out.write('Domain Averages WAS NOT run.\n\n')

	out.close()


## User Set Variables: Atmospheric Levels (mb) ##
## CHANGE THESE ONLY IF YOU ABSOLUTELY NEED TO ##

level1 = 850
level2 = 500
level3 = 200

## Header for logfile:

logheader()

## Open the directories file and create a dictionary for directories.

dirdict = {}

for line in open('directories'):
#	print line
	L = []
	L = line.split(' ')
#	print L
	name = L[0]
	path = L[1]
	path = path.strip('\n\r')
	dirdict[name] = path

experiment = dirdict.keys()

#print 'Directory dictionary is as follows: ' + str(dirdict)
#print

## Open the config files and create a dictionary for config.

confdict = {}

for line in open('maps_config'):
#       print line
        L = []
        L = line.split(' ')
#       print L
        name = L[0]
        path = L[1]
        path = path.strip('\n\r')
        confdict[name] = path

#print 'Config dictionary is as follows: ' + str(confdict)
#print

## Open the range config file and create a dictionary for ranges.

rangedict = {}

for line in open('ranges'):
#       print line
        L = []
        L = line.split(' ')
#       print L
        name = L[0]
        rangbegin = L[1]
	rangend = L[2]
        rangend = rangend.strip('\n\r')
        rangedict[name] = rangbegin + '-' + rangend 

#print 'Ranges dictionary is as follows: ' + str(rangedict)
#print

try:
	fstep = s.argv[1]
	domain = s.argv[2]
	chr = s.argv[3]
	fhr = s.argv[4]
	step = s.argv[5]
except:
	print 'Script usage: python maps_master.py step d# beginhr endhr hradv'
	quit(2)

first = True
errno = 0
numerr = 0

# This will make graphics for every directory as per the config file.

for exp in experiment:

	if not os.path.exists('./' + exp + '_d0' + domain):
		print "Creating new directory..."
		os.mkdir('./' + exp + '_d0' + domain)

	rootlist = []

	try:
		datelist = datelistgen(rangedict[exp], fstep)
	except KeyError:
		print 'ERROR: Mismatching names. Make sure the experiment names in the config file'
		print 'are in the same order in all files.'
		errorlogother(101)
		quit(1)
	except:
		print 'ERROR: Unknown Error.\n', sys.exc_info() [0]
		errno = -1
		errorlogother(errno)
		logfootererror(errno)
		raise

	for date in datelist:
		try:
			direc = datedecoder(confdict[exp], date)
			direc = domaindecoder(direc, domain)
	        except KeyError:
        	        print 'ERROR: Mismatching names. Make sure the experiment names in the config files'
        	        print 'are in the same order in ALL files.'
			errorlogother(101)
        	        quit(1)
     		except:
                	print 'ERROR: Unknown Error.\n', sys.exc_info() [0]
			errno = -1
			errorlogother(errno)
			logfootererror(errno)
                	raise

		A = direc.find('#')
		B = A + 3
		endloc = direc[B:]
		direc = direc[:A]

		rtypspl = direc.split('/')
		rtyp = rtypspl[len(rtypspl) - 1]

		A = direc.find(rtyp)
		A = A - 1
		direc = direc[:A]

 		rootlist.append((date, direc, rtyp))

 	for T in rootlist:
		if first:
			print 'Starting first run...'
			logexp(exp)
			prevrun = ''
			t.sleep(1)
			first = False
		else:
			print 'Starting next run...'

			if prevrun != run:
				logexp(exp)

			t.sleep(1)

		start = T[0]
		root1 = T[1]
		roottype = T[2]
		rootend = endloc
		run = str(exp)
		title = str(exp) + '_' + 'd0' + str(domain)

		nc_root1 = dirdict[exp] + '/' + root1

#		print root1, roottype

		print 'Writing to config...'

		configcreator(nc_root1, roottype, rootend, title, level1, level2, level3)

		namconv = str(roottype) + '###' + str(rootend)

		print 'Directory is: ' + nc_root1
		print 'Naming convention is: ' + namconv
		print 'This run is: ' + title
		print 'The forcast time is: ' + str(start) + '\n'

		t.sleep(1)

		print 'Running wrfout_process.sh...'

		t.sleep(1)

		cmd = str(start) + ' ' + str(chr) + ' ' + str(fhr) + ' ' + str(step)

		try:
			rc = proc.call("./wrfout_process.sh " + cmd, shell=True)
			if rc > 0:
				numerr = numerr + 1
				errorlog(title, nc_root1, rc, numerr)
				print 'Errors detected via wrfout processor. Check maps_master_log.txt.'
		except:
			print 'FATAL ERROR! WRFOUT_PROCESS.SH MISSING.'
			errorlogother(102)
			quit()

		if rc == 0:
			if os.path.exists('./' + str(start) + '_' + title):
				print 'Moving graphics to folder...'
				maindir = './' + exp + '_d0' + domain
				subdir = './' + str(start) + '_' + title
				try:
					shutil.move(subdir, maindir)
  				except:
                        		print "WARNING: The directory " + str(maindir) + "/" + str(subdir) + " already exists and will be overwritten."
					os.chdir(maindir)
					shutil.rmtree(subdir)
					os.chdir('..')
					shutil.move(subdir, maindir)
				
				loggen(start, rc)
		t.sleep(1)
		prevrun = run
		print

print 'Maps finished. Preparing to calculate domain averages.\n'

quit()

## Domain Average Calculation.

print 'Writing to da_config...'

da_configcreator(run, level1, level2, level3, domain)

print 'Calculating domain averages...'

titlelist = []

for exp in experiment:
	title = str(exp) + '_' + 'd0' + str(domain)
	titlelist.append(title)

try:
	for title in titlelist:
		darc = proc.call('python ./domain_average.py ' + str(title) + ' ' + str(domain) + ' ' + str(step), shell=True)
		da = True
		da_check(da, darc)
except:
	print 'WARNING: domain_avarage.py not found. Domain averages will not be calculated unless this script is present.'
	darc = 0
	da = False
	da_check(da, darc)

logfooter(numerr)

quit()
