* Plot Tracker GrADS Script
* Created by: Bryan M. Williams on July 31, 2013

* This script will plot the track of the Nature Run along with the model and/or experimental run. 

Function main(args)
NR=subwrd(args,1)
fcst=subwrd(args,2)
expname=subwrd(args,3)

*** CONFIGURATION ***

NRmarktype=2
NRmarksize=0.11
NRlcolor=2
NRlstyle=1
NRlthick=8

ANAmarktype=4
ANAmarksize=0.09
ANAlcolor=3
ANAlstyle=1
ANAlthick=1

FORmarktype=8
FORmarksize=0.09
FORlcolor=4
FORlstyle=1
FORlthick=1

*** SCRIPT IS BELOW THIS LINE. ***

*** 1. Open one of the text files to find a suitible window area. ***

res=read(fcst)

amax=0
amin=0
omax=0
omin=0
first=1

rc=sublin(res,1)
while(rc!=2)
  time=subwrd(res,2)
  lati=subwrd(res,7)
  long=subwrd(res,6)
  mcp=subwrd(res,8)
  wind=subwrd(res,9)
  if(amax < lati | amax = 0)
    amax=lati
  endif
  if(amin > lati | amin = 0)
    amin=lati
  endif
  if(omax < long | omax = 0)
    omax=long
  endif
  if(omin > long | omin = 0)
    omin=long
  endif
  res=read(fcst)
  rc=sublin(res,1)
  if(rc=2)
*   say 'Return code 2!'
    res=close(fcst)
  endif
endwhile

*'set parea 1 9 0.5 7.5'
'run plotnot.gs 'omin-3' 'omax+3' 'amin-2' 'amax+2

*** 2. Display the track. ***

* Load the forecast track file

f_res=read(fcst)

f_rc=sublin(f_res,1)

if(f_rc=0)
  f_date=subwrd(f_res,2)
  start=f_date
endif

* Load the nature run file

nr_res=read(NR)

* Get the first date from the nature file

rawdate=subwrd(nr_res,2)

YYYY=substr(rawdate,1,4)
MM=substr(rawdate,6,2)
DD=substr(rawdate,9,2)
HH=substr(rawdate,12,2)

nr_date = YYYY%MM%DD%HH

* Cycle through dates until the one matching the start date from the forecast file is found.

while(f_date != nr_date)
  nr_res=read(NR)

  rawdate=subwrd(nr_res,2)

  YYYY=substr(rawdate,1,4)
  MM=substr(rawdate,6,2)
  DD=substr(rawdate,9,2)
  HH=substr(rawdate,12,2)

  nr_date = YYYY%MM%DD%HH
endwhile


* Plot the track(s).

while(f_rc = 0)

  if(f_rc = 2)
    break
  endif
* * First point
  
  if(first)

    nr_laprev=subwrd(nr_res,6)
    nr_loprev=subwrd(nr_res,7)

    'q w2xy 'nr_loprev' 'nr_laprev
    nr_xprev=subwrd(result,3)
    nr_yprev=subwrd(result,6)
    'set line 'NRlcolor' 'NRlstyle' 'NRlthick
    'draw mark 'NRmarktype' 'nr_xprev' 'nr_yprev' 'NRmarksize

    f_count=0
         
    f_type=subwrd(f_res,3)
    f_laprev=subwrd(f_res,7)
    f_loprev=subwrd(f_res,6)

    while(1)
      if(substr(f_type,strlen(f_type),1) = 'f')
*       say 'forecast'
        'q w2xy 'f_loprev' 'f_laprev
        f_xprev=subwrd(result,3)
        f_yprev=subwrd(result,6)
        'set line 'FORlcolor' 'FORlstyle' 'FORlthick
        'draw mark 'FORmarktype' 'f_xprev' 'f_yprev' 'FORmarksize

        f_res=read(fcst)
      endif

      if(substr(f_type,strlen(f_type),1) = 'a')
        'q w2xy 'f_loprev' 'f_laprev
        f_xprev=subwrd(result,3)
        f_yprev=subwrd(result,6)
        'set line 'ANAlcolor' 'ANAlstyle' 'ANAlthick
        'draw mark 'ANAmarktype' 'f_xprev' 'f_yprev' 'ANAmarksize 
       
        a_xprev=f_xprev
        a_yprev=f_yprev

        f_res=read(fcst)
      endif

      f_type=subwrd(f_res,3)
      f_count=f_count+1

      if(f_count = 2)
        f_count=0
        break
      endif

    endwhile

    first=0

  else
    nr_lanext=subwrd(nr_res,6)
    nr_lonext=subwrd(nr_res,7)

    'q w2xy 'nr_lonext' 'nr_lanext
    nr_xnext=subwrd(result,3)
    nr_ynext=subwrd(result,6)
    'set line 'NRlcolor' 'NRlstyle' 'NRlthick
    'draw mark 'NRmarktype' 'nr_xnext' 'nr_ynext' 'NRmarksize
    'draw line 'nr_xprev' 'nr_yprev' 'nr_xnext' 'nr_ynext    

*   f_count=0

    f_type=subwrd(f_res,3)
    f_lanext=subwrd(f_res,7)
    f_lonext=subwrd(f_res,6)

    while(1)
*     say f_date' 'f_type
      if(substr(f_type,strlen(f_type),1) = 'f') 
*       say 'forecast'

        'q w2xy 'f_lonext' 'f_lanext
        f_xnext=subwrd(result,3)
        f_ynext=subwrd(result,6)
        'set line 'FORlcolor' 'FORlstyle' 'FORlthick
        'draw mark 'FORmarktype' 'f_xnext' 'f_ynext' 'FORmarksize
        'draw line 'f_xprev' 'f_yprev' 'f_xnext' 'f_ynext

        f_res=read(fcst)
      endif

      if(substr(f_type,strlen(f_type),1) = 'a')
*       say 'experiment'

        'q w2xy 'f_lonext' 'f_lanext
        f_xnext=subwrd(result,3)
        f_ynext=subwrd(result,6)
        'set line 'ANAlcolor' 'ANAlstyle' 'ANAlthick
        'draw mark 'ANAmarktype' 'f_xnext' 'f_ynext' 'ANAmarksize
        'draw line 'a_xprev' 'a_yprev' 'f_xnext' 'f_ynext

        a_xprev=f_xnext
        a_yprev=f_ynext

        f_res=read(fcst)
      endif

      f_type=subwrd(f_res,3)
      f_count=f_count+1

      if(f_count = 2)
        f_count=0
        break
      endif

    endwhile
    
    nr_xprev=nr_xnext
    nr_yprev=nr_ynext
    f_xprev=f_xnext
    f_yprev=f_ynext
 
  endif
  
  f_date=subwrd(f_res,2)
  f_rc=sublin(f_res,1)

  while(f_date != nr_date)
    nr_res=read(NR)

    rawdate=subwrd(nr_res,2)

    YYYY=substr(rawdate,1,4)
    MM=substr(rawdate,6,2)
    DD=substr(rawdate,9,2)
    HH=substr(rawdate,12,2)
    ii=substr(rawdate,14,2)

    if(ii != 30)
      nr_date = YYYY%MM%DD%HH
    endif
  endwhile

  if(f_rc = 2)
    break
  endif

  if(f_rc=0)
   end=f_date 
  endif

* say nr_date' 'f_date

endwhile


*return


*** 3. Create a legend (Key). ***

* Draw box where key will go.

pxlo= 9.2
pxhi= 10.8
pylo= 4.3
pyhi= 5.5

int=0.2

*'set parea 'pxlo' 'pxhi' 'pylo' 'pyhi
'set ccolor 1'
'set line 1 1 4'
'draw line 'pxlo' 'pylo' 'pxhi' 'pylo
'draw line 'pxhi' 'pylo' 'pxhi' 'pyhi
'draw line 'pxhi' 'pyhi' 'pxlo' 'pyhi
'draw line 'pxlo' 'pyhi' 'pxlo' 'pylo

* Draw lines and marks.

starty=pyhi-0.2
startx=pxlo+0.2

'set line 'NRlcolor' 'NRlstyle' 'NRlthick
'draw line 'startx' 'starty' 'startx+0.3' 'starty
'draw mark 'NRmarktype' 'startx+0.15' 'starty' 'NRmarksize
'draw string 'startx+0.45' 'starty-0.05' Nature'

'set line 'ANAlcolor' 'ANAlstyle' 'ANAlthick
'draw line 'startx' 'starty-0.4' 'startx+0.3' 'starty-0.4
'draw mark 'ANAmarktype' 'startx+0.15' 'starty-0.4' 'ANAmarksize
'draw string 'startx+0.45' 'starty-0.45' Analysis'

'set line 'FORlcolor' 'FORlstyle' 'FORlthick
'draw line 'startx' 'starty-0.8' 'startx+0.3' 'starty-0.8
'draw mark 'FORmarktype' 'startx+0.15' 'starty-0.8' 'FORmarksize
'draw string 'startx+0.45' 'starty-0.85' Forecast'

'draw title Comparison of Tracks\'expname' from 'start' to 'end

'set string 1 c'
'draw string 'pxlo+0.8' 'pyhi+0.2' KEY'

*'printim 'expname'_fcst_track.png x1600 y1200'
