#! /bin/sh

if [ $# -lt 2 ]
 then
  echo "Please enter a datestring (YYYYMMDDHH) and an hour (ie, 2, -120, etc)."
  exit 0
fi

###Read user inputs###
export date=${1}
export inthr=${2}

###Define internal variables###
export year=`echo $date | cut -c1-4`
export month=`echo $date | cut -c5-6`
export day=`echo $date | cut -c7-8`
export hour=`echo $date | cut -c9-10`

###Remove leading "0"###
if [ $hour -lt 10 ]
 then
  hour=`echo $hour | cut -c2`
fi

if [ $day -lt 10 ]
 then
  day=`echo $day | cut -c2`
fi

if [ $month -lt 10 ]
 then
  month=`echo $month | cut -c2`
fi

#######Determine output date#######

##Determine hour

hour=`expr $hour + $inthr`

while [ $hour -ge 24 ]
 do
  hour=`expr $hour - 24`
  day=`expr $day + 1`
done

while [ $hour -lt 0 ]
 do
  hour=`expr $hour + 24`
  day=`expr $day - 1`
done

##Determine if leap year

export leapyear=0
export rmdr1=`expr $year % 4`
export rmdr2=`expr $year % 100`

if [[ $rmdr1 -eq 0  ]] && [[ $rmdr2 -ne 0  ]]
 then
  export leapyear=1
fi

##Determine day and month

if [[ $month -eq 1 ]] || [[ $month -eq 3 ]] || [[ $month -eq 5 ]] || [[ $month -eq 7 ]] || [[ $month -eq 8 ]] || [[ $month -eq 10 ]] || [[ $month -eq 12 ]]
   then
    export enddate=31
fi

if [[ $month -eq 4 ]] || [[ $month -eq 6 ]] || [[ $month -eq 9 ]] || [[ $month -eq 11 ]]
   then
    export enddate=30
fi

if [[ $month -eq 2  ]] && [[ $leapyear -eq 0  ]]
   then
    export enddate=28
fi

if [[ $month -eq 2  ]] && [[ $leapyear -eq 1  ]]
  then
    export enddate=29
fi

while [[ $day -gt $enddate ]]
 do
  day=`expr $day - $enddate`
  month=`expr $month + 1`

  if [[ $month -gt 12 ]]
   then
    month=`expr $month - 12`
    year=`expr $year + 1`
  fi

  if [[ $month -eq 1 ]] || [[ $month -eq 3 ]] || [[ $month -eq 5 ]] || [[ $month -eq 7 ]] || [[ $month -eq 8 ]] || [[ $month -eq 10 ]] || [[ $month -eq 12 ]]
     then
      export enddate=31
  fi

  if [[ $month -eq 4 ]] || [[ $month -eq 6 ]] || [[ $month -eq 9 ]] || [[ $month -eq 11 ]]
     then
      export enddate=30
  fi

  if [[ $month -eq 2  ]] && [[ $leapyear -eq 0  ]]
     then
      export enddate=28
  fi

  if [[ $month -eq 2  ]] && [[ $leapyear -eq 1  ]]
     then
      export enddate=29
  fi

done

while [[ $day -lt 0 ]]
 do
  month=`expr $month - 1`

  if [[ $month -lt 0 ]]
   then
    month=`expr $month + 12`
    year=`expr $year - 1`
  fi

  if [[ $month -eq 1 ]] || [[ $month -eq 3 ]] || [[ $month -eq 5 ]] || [[ $month -eq 7 ]] || [[ $month -eq 8 ]] || [[ $month -eq 10 ]] || [[ $month -eq 12 ]]
     then
      export enddate=31
  fi

  if [[ $month -eq 4 ]] || [[ $month -eq 6 ]] || [[ $month -eq 9 ]] || [[ $month -eq 11 ]]
     then
      export enddate=30
  fi

  if [[ $month -eq 2  ]] && [[ $leapyear -eq 0  ]]
     then
      export enddate=28
  fi

  if [[ $month -eq 2  ]] && [[ $leapyear -eq 1  ]]
     then
      export enddate=29
  fi

  day=`expr $day + $enddate`

done

if [[ $hour -lt 10  ]] && [[ `expr length "$hour"` -lt 2 ]]
 then
  hour=0$hour
fi

if [[ $day -lt 10  ]] && [[ `expr length "$day"` -lt 2 ]]
 then
  day=0$day
fi

if [[ $month -lt 10  ]] && [[ `expr length "$month"` -lt 2 ]]
 then
  month=0$month
fi

echo $year$month$day$hour
