* Line graph creator for Wind (for MPlot) 
* Created by: Bryan M. Williams on September 13, 2013

Function main(args)
run1=subwrd(args,1)
run2=subwrd(args,2)
start_date=subwrd(args,3)
xint=subwrd(args,4)
xmax=subwrd(args,5)
level1=subwrd(args,6)
level2=subwrd(args,7)
level3=subwrd(args,8)

* Pre-Script Tasks

'reinit'
'set display color white'
'c'

*'!mkdir graphs'

* Set dimensions.

pxlo=1.3
pxhi=9
pylo=1.5
pyhi=7.5

** LEGEND DIMENSIONS **

pxlo_l=9.2
pxhi_l=10.9
pylo_l=3.1
pyhi_l=5.5

yint=0.1
xlab='Forecast Hour'
ylab='Error (m/s)'
title1='Wind Speed Mean Error and RMS'
title2='('run2' - 'run1') 'start_date

'set rgb 16 34 139 34'

AVGmarktype1=2
AVGmarksize1=0.09
AVGlcolor1=2
AVGlstyle1=3
AVGlthick1=6

RMSmarktype1=4
RMSmarksize1=0.09
RMSlcolor1=2
RMSlstyle1=1
RMSlthick1=6

AVGmarktype2=2
AVGmarksize2=0.09
AVGlcolor2=16
AVGlstyle2=3
AVGlthick2=6

RMSmarktype2=4
RMSmarksize2=0.09
RMSlcolor2=16
RMSlstyle2=1
RMSlthick2=6

AVGmarktype3=2
AVGmarksize3=0.09
AVGlcolor3=4
AVGlstyle3=3
AVGlthick3=6

RMSmarktype3=4
RMSmarksize3=0.09
RMSlcolor3=4
RMSlstyle3=1
RMSlthick3=6

xmin=0
*xmax=60
*ymin=-1.5
*ymax=1.5

*say ' '
*say 'This is the Line Graph for abs. mean of MSLP for date 'start_date'.'
*say '-------------------------------------------------------------------'
*say ' '

* Draw Graph Area.

say 'Drawing graph area...'

*'set parea 'pxlo' 'pxhi' 'pylo' 'pyhi
'set ccolor 1'
'set line 1 1 4'
'draw line 'pxlo' 'pylo' 'pxhi' 'pylo
'draw line 'pxhi' 'pylo' 'pxhi' 'pyhi
'draw line 'pxhi' 'pyhi' 'pxlo' 'pyhi
'draw line 'pxlo' 'pyhi' 'pxlo' 'pylo

xdif = (pxhi - pxlo)/(xmax - xmin)

* Set up axes.

* * Y-axis

* Determine min and max.

say 'Determining values for y-axis...'

rc=0
ymin=0
ymax=0
res=read('wind_'level1'_'start_date'.txt')
rc=sublin(res,1)
first=1
while(rc=0)
  yval=subwrd(res,3)
  if(ymax < yval)
    ymax=yval
  endif
  if(yval < ymin)
    ymin=yval
  endif

  if(first)
    ymin=yval
    ymax=yval
    first=0
  endif

  yval=subwrd(res,4)
  if(ymax < yval)
    ymax=yval
  endif
  if(yval < ymin)
    ymin=yval
  endif
  
  res=read('wind_'level1'_'start_date'.txt')
  rc=sublin(res,1)
  if(rc != 0)
    if(rc = 2)
*     say 'Determining axis bounds: End of file reached.'
*     say ' '
      break
    else
      say 'CRITICAL! Error code 'rc'.'
      return
    endif
  endif
endwhile

res=close('wind_'level1'_'start_date'.txt')

res=read('wind_'level2'_'start_date'.txt')
rc=sublin(res,1)
while(rc=0)
  yval=subwrd(res,3)
  if(ymax < yval)
    ymax=yval
  endif
  if(yval < ymin)
    ymin=yval
  endif

  yval=subwrd(res,4)
  if(ymax < yval)
    ymax=yval
  endif
  if(yval < ymin)
    ymin=yval
  endif

  res=read('wind_'level2'_'start_date'.txt')
  rc=sublin(res,1)
  if(rc != 0)
    if(rc = 2)
*     say 'Determining axis bounds: End of file reached.'
*     say ' '
      break
    else
      say 'CRITICAL! Error code 'rc'.'
      return
    endif
  endif
endwhile

res=close('wind_'level2'_'start_date'.txt')

res=read('wind_'level3'_'start_date'.txt')
rc=sublin(res,1)
while(rc=0)
  yval=subwrd(res,3)
  if(ymax < yval)
    ymax=yval
  endif
  if(yval < ymin)
    ymin=yval
  endif

  yval=subwrd(res,4)
  if(ymax < yval)
    ymax=yval
  endif
  if(yval < ymin)
    ymin=yval
  endif

  res=read('wind_'level3'_'start_date'.txt')
  rc=sublin(res,1)
  if(rc != 0)
    if(rc = 2)
*     say 'Determining axis bounds: End of file reached.'
*     say ' '
      break
    else
      say 'CRITICAL! Error code 'rc'.'
      return
    endif
  endif
endwhile

res=close('wind_'level3'_'start_date'.txt')

if(ymin < 0 | ymin > 1)
  ymin=math_format('%.1f',ymin) - 0.1
endif

if(ymin > 0 & ymin < 1)
  ymin=0
endif

ymax=math_format('%.2f',ymax) + 0.1

ydif = (pyhi - pylo)/(ymax - ymin)

if(ymin < 0 & ymax > 0)
  zero=pylo+(0-ymin)*ydif
  'set rgb 20 200 200 200'
  'set line 20 4 1'
  'draw line 'pxlo' 'zero' 'pxhi' 'zero
  'set string 20'
  'set string 20 bl 2 0'
  'set strsiz 0.10 0.12'
  'draw string 'pxlo+0.05' 'zero+0.05' 0.00'
  'draw string 'pxhi-0.40' 'zero+0.05' 0.00'
  'set string 1'
  'set line 1 1 1'
endif

say 'Creating y-axis...'

num=math_abs((ymax-ymin)/ yint)
num=math_format('%.0f',num)
say 'Initial number of y labels, according to yint: 'num

if(num > 15)
 say 'The y-axis has too many labels! Max number is 15. Increasing yint by increments of 'yint*2'...'
 while(num > 15)
   yint=yint*2
   num=math_abs((ymax-ymin) / yint)
   num=math_format('%.0f',num)
   if(num <= 15)
     say 'Done. New yint is: 'yint
   endif
 endwhile
else
  say 'Number of y-axis labels are at or below the maximum of 15. Continuing...'
endif

yy = ymin
'set string 1 r 2 0'
'set strsiz 0.10 0.12'
while (yy<=ymax & yy>=ymin)
y = pylo+(yy-ymin)*ydif
xa=pxlo-0.09
xl=pxlo-0.1
'draw line 'xa' 'y' 'pxlo' 'y
rc = math_format('%.2f',yy)
'draw string 'xl' 'y' 'rc
yy = yy + yint
endwhile


* * X-axis

say 'Creating X-axis (FHR)...'

oldlbl=0
lbl=0

xx = xmin
'set string 1 bc 2 70'
'set strsiz 0.10 0.12'
res = read('wind_'level1'_'start_date'.txt')
rc = sublin(res,1)

while (xx<=xmax & xx>=xmin & rc=0)
  line = sublin(res,2)
  if(lbl >= oldlbl)
    lbl=subwrd(res,2)
    x=pxlo+(xx-xmin)*xdif
    ya=pylo-0.04
    y=pylo-0.23
    say 'plotting... 'lbl
    'draw line 'x' 'pylo' 'x' 'ya
    if(xint < 6)
      if(math_fmod(lbl,6) = 0)
        'draw string 'x' 'y' 'lbl
      endif
    endif
    if(xint >= 6)
      'draw string 'x' 'y' 'lbl
    endif
    xx = xx + xint
    oldlbl = lbl
  endif
  lasthr=subwrd(res,2) 
  res = read('wind_'level1'_'start_date'.txt')
  rc = sublin(res,1)
  if(rc != 0)
*   say 'Return Code: 'rc
*   say 'End of file reached.'
    say ' '
    break
  endif
* say 'Return Code: 'rc
endwhile

res = close('wind_'level1'_'start_date'.txt')

* Graph Forecast hour vs. area average.

say 'Drawing Graph...'

first=0
res1 = read('wind_'level1'_'start_date'.txt')
res2 = read('wind_'level2'_'start_date'.txt')
res3 = read('wind_'level3'_'start_date'.txt')

rc1 = sublin(res1,1)
rc2 = sublin(res2,1)
rc3 = sublin(res3,1)

while (rc1=0 & rc2=0 & rc3=0)

  fhr = subwrd(res1,2)
  aavg1 = subwrd(res1,3)
  arms1 = subwrd(res1,4)

  aavg2 = subwrd(res2,3)
  arms2 = subwrd(res2,4)

  aavg3 = subwrd(res3,3)
  arms3 = subwrd(res3,4)

  x = fhr

  ya1 = aavg1
  yr1 = arms1

  ya2 = aavg2
  yr2 = arms2

  ya3 = aavg3
  yr3 = arms3

  x = pxlo+(x-xmin)*xdif

  ya1 = pylo+(ya1-ymin)*ydif
  yr1 = pylo+(yr1-ymin)*ydif

  ya2 = pylo+(ya2-ymin)*ydif
  yr2 = pylo+(yr2-ymin)*ydif

  ya3 = pylo+(ya3-ymin)*ydif
  yr3 = pylo+(yr3-ymin)*ydif

  'set line 'AVGlcolor1' 'AVGlstyle1' 'AVGlthick1
* 'draw mark 'AVGmarktype1' 'x' 'ya1' 'AVGmarksize1

  'set line 'RMSlcolor1' 'RMSlstyle1' 'RMSlthick1
* 'draw mark 'RMSmarktype1' 'x' 'yr1' 'RMSmarksize1

  'set line 'AVGlcolor2' 'AVGlstyle2' 'AVGlthick2
* 'draw mark 'AVGmarktype2' 'x' 'ya2' 'AVGmarksize2

  'set line 'RMSlcolor2' 'RMSlstyle2' 'RMSlthick2
* 'draw mark 'RMSmarktype2' 'x' 'yr2' 'RMSmarksize2

  'set line 'AVGlcolor3' 'AVGlstyle3' 'AVGlthick3
* 'draw mark 'AVGmarktype3' 'x' 'ya3' 'AVGmarksize3
 
  'set line 'RMSlcolor3' 'RMSlstyle3' 'RMSlthick3
* 'draw mark 'RMSmarktype3' 'x' 'yr3' 'RMSmarksize3

  if(first)
    'set line 'AVGlcolor1' 'AVGlstyle1' 'AVGlthick1
    'draw line 'xold' 'ya1old' 'x' 'ya1
    
    'set line 'RMSlcolor1' 'RMSlstyle1' 'RMSlthick1
    'draw line 'xold' 'yr1old' 'x' 'yr1

    'set line 'AVGlcolor2' 'AVGlstyle2' 'AVGlthick2
    'draw line 'xold' 'ya2old' 'x' 'ya2

    'set line 'RMSlcolor2' 'RMSlstyle2' 'RMSlthick2
    'draw line 'xold' 'yr2old' 'x' 'yr2

    'set line 'AVGlcolor3' 'AVGlstyle3' 'AVGlthick3
    'draw line 'xold' 'ya3old' 'x' 'ya3

    'set line 'RMSlcolor3' 'RMSlstyle3' 'RMSlthick3
    'draw line 'xold' 'yr3old' 'x' 'yr3
  endif

  first = 1

  xold = x

  ya1old = ya1
  yr1old = yr1

  ya2old = ya2
  yr2old = yr2

  ya3old = ya3
  yr3old = yr3

  res1 = read('wind_'level1'_'start_date'.txt')
  res2 = read('wind_'level2'_'start_date'.txt')
  res3 = read('wind_'level3'_'start_date'.txt')

  rc1 = sublin(res1,1)
  rc2 = sublin(res2,1)
  rc3 = sublin(res3,1)

endwhile

mid=(pxhi+pxlo)/2

*** Create a legend (key), x- and y-axis label, and title. ***

* Legend (Key)

* Draw box where key will go.

int=0.2

'set parea 'pxlo_l' 'pxhi_l' 'pylo_l' 'pyhi_l
'set ccolor 1'
'set line 1 1 4'
'draw line 'pxlo_l' 'pylo_l' 'pxhi_l' 'pylo_l
'draw line 'pxhi_l' 'pylo_l' 'pxhi_l' 'pyhi_l
'draw line 'pxhi_l' 'pyhi_l' 'pxlo_l' 'pyhi_l
'draw line 'pxlo_l' 'pyhi_l' 'pxlo_l' 'pylo_l

* Draw lines and marks.

starty=pyhi_l-0.2
startx=pxlo_l+0.2

'set string 1 bl 0 0'

'set line 'AVGlcolor1' 'AVGlstyle1' 'AVGlthick1
'draw line 'startx' 'starty' 'startx+0.3' 'starty
'set line 'AVGlcolor1' 'AVGlstyle1' 'AVGlthick1
'draw mark 'AVGmarktype1' 'startx+0.15' 'starty' 'AVGmarksize1
'draw string 'startx+0.40' 'starty-0.05' 'level1'mb Mean'

'set line 'RMSlcolor1' 'RMSlstyle1' 'RMSlthick1
'draw line 'startx' 'starty-0.4' 'startx+0.3' 'starty-0.4
'set line 'RMSlcolor1' 'RMSlstyle1' 'RMSlthick1
'draw mark 'RMSmarktype1' 'startx+0.15' 'starty-0.4' 'RMSmarksize1
'draw string 'startx+0.40' 'starty-0.45' 'level1'mb RMS'

'set line 'AVGlcolor2' 'AVGlstyle2' 'AVGlthick2
'draw line 'startx' 'starty-0.8' 'startx+0.3' 'starty-0.8
'set line 'AVGlcolor2' 'AVGlstyle2' 'AVGlthick2
'draw mark 'AVGmarktype2' 'startx+0.15' 'starty-0.8' 'AVGmarksize2
'draw string 'startx+0.40' 'starty-0.85' 'level2'mb Mean'

'set line 'RMSlcolor2' 'RMSlstyle2' 'RMSlthick2
'draw line 'startx' 'starty-1.2' 'startx+0.3' 'starty-1.2
'set line 'RMSlcolor2' 'RMSlstyle2' 'RMSlthick2
'draw mark 'RMSmarktype2' 'startx+0.15' 'starty-1.2' 'RMSmarksize2
'draw string 'startx+0.40' 'starty-1.25' 'level2'mb RMS'

'set line 'AVGlcolor3' 'AVGlstyle3' 'AVGlthick3
'draw line 'startx' 'starty-1.6' 'startx+0.3' 'starty-1.6
'set line 'AVGlcolor3' 'AVGlstyle3' 'AVGlthick3
'draw mark 'AVGmarktype3' 'startx+0.15' 'starty-1.6' 'AVGmarksize3
'draw string 'startx+0.40' 'starty-1.65' 'level3'mb Mean'

'set line 'RMSlcolor3' 'RMSlstyle3' 'RMSlthick3
'draw line 'startx' 'starty-2.0' 'startx+0.3' 'starty-2.0
'set line 'RMSlcolor3' 'RMSlstyle3' 'RMSlthick3
'draw mark 'RMSmarktype3' 'startx+0.15' 'starty-2.0' 'RMSmarksize3
'draw string 'startx+0.40' 'starty-2.05' 'level3'mb RMS'

'set string 1 c 1 0'
'draw string 'pxlo_l+0.8' 'pyhi_l+0.2' KEY'

* Draw Titles and axes labels.

* X-axis label

'set strsiz 0.2'
'set string 1 c 10 0'
'draw string 'mid' 0.5 'xlab

* Y-axis label

'set strsiz 0.2'
'set string 1 c 10 90'
'draw string 0.3 4 'ylab

* Title
'set strsiz 0.2'
'set string 1 c 10 0'
'draw string 'mid' 8.3 'title1
'draw string 'mid' 7.9 'title2

'printim wind_'start_date'_graph.png x1600 y1200'
 

say 'Done. Graph completed.'
